#!/usr/bin/php
<?php
include('/usr/local/opmon/share/opcfg/includes/adodb/adodb.inc.php');

$db = null;
$DBNAME = "agendar";
$DBUSER = "root";
$DBPASS = "oppass";
$DBHOST = "35.185.56.196"; // agendar.io database

/* metrics and queries */
$queries = array();
$queries['professionals'] = 'select count(*) as total from professional;';
$queries['customers'] = 'select count(*) as total from customer;';
$queries['schedules'] = 'select count(*) as total from customer where created_at >= (UNIX_TIMESTAMP(DATE_SUB(CURDATE(), INTERVAL 10 DAY)) * 1000);';

if (!db_connect()) {
	print "Cound not connect to the database\n";
	exit(0);
}

$plugins_output = '';
$perf_data = '';
foreach ($queries as $metric => $query) {
	$value = 0;
	$result = db_query($query);
	if ($result !== false) {
		$value = $result->fields['total'];
		$result->Close();
	}
	if (empty($plugins_output)) {
		$plugins_output = $metric." ".$value;
		$perf_data = $metric."=".$value;
	}
	else {
		$plugins_output .= " - ".$metric." ".$value;
		$perf_data .= " ".$metric."=".$value;
	}
}
print $plugins_output. " | ".$perf_data."\n";


exit(0);

function db_connect() {
	global $db;
	global $DBUSER,	$DBPASS, $DBHOST, $DBNAME;

	if ($db!==null && !$db->isConnected()) {
		$db->close();
	}

	/* 
	$db = adoNewConnection('mysqli'); # eg. 'mysqli' or 'oci8'
	$db->debug = false;
	$ret = $db->pConnect($DBHOST, $DBUSER, $DBPASS, 'opcfg');
	*/
	

	/* $db = adoNewConnection('mysql'); # eg. 'mysqli' or 'oci8'
	$db->debug = false;
	$ret = $db->pConnect($DBHOST, $DBUSER, $DBPASS, 'opcfg');
	*/
	
	$db = ADOnewConnection('pdo');
	$dsnString= "host=$DBHOST;dbname=$DBNAME;charset=utf8mb4";
	$ret = $db->pConnect('mysql:'.$dsnString,$DBUSER,$DBPASS);

	return $ret;
}

function db_query($sql) {
	global $db;

	if (!$db->isConnected()) {
		db_connect();
	}
	$rs = $db->execute($sql);
	if ($rs === false) {
		print $db->errorMsg()."\n";
	}
	return $rs;
}

/* reuturn 0 for INSERTS and 1 for UPDATEs */
function db_autoExecute($table,$record) { 
	global $db, $fieldMapping;

	$operation = 0;

	/* build primary key */
	$where = '';
	foreach ($fieldMapping['primary_key_fields'] as $field) {
		if (empty($where)) {
			$where = $field." = '".$record[$field]."'";
		}
		else {
			$where .= ' AND '.$field." = '".$record[$field]."'";
		}
	}

	/* detect insert vs update */
	$sql = "SELECT * FROM $table WHERE $where";
	$result = $db->execute($sql);
	if ($result !== false) {
		if ($db->affected_rows()!==false and $db->affected_rows() > 0) { // UPDATE
			$sql = $db->getUpdateSql($result,$record,true);
			$result->close();
			$operation = 1;
		}
		else if ($db->affected_rows()!==false and $db->affected_rows() == 0) { // INSERT
			$sql = $db->getInsertSql($result,$record);
		}
	}
	/* Do it */
	$result = $db->execute($sql);
	return $operation;
}

?>
