<?php
include_once("/usr/local/opmon/etc/config.php");
set_logged_user("opmonadmin");

$hostname = $argv[1];
$conn = Livestatus\Connection\ConnectionProvider::factory("tcp");
$query = $conn->from("services");
$query->select(
    [
        "description",
        "display_status",
        "state_type",
        "process_performance_data"
	]
);
$query->filterBy(
	$conn->createFilter(
		array(
			"host_name",
			Livestatus\LQL\Factory::createOperator("="),
			$hostname
		)
	)
);

$services = $conn->execute()->fetchAll();
if (count($services) === 0) {
	print "IC sem KPIs".PHP_EOL;
	exit(0);
}

$availProblems = [];
$unknowns = 0;
foreach ($services as $service) {
	if ($service->state_type == 1) {
		if ($service->process_performance_data == 0 &&
			($service->display_status == 5 || $service->display_status == 6)
		) {
			$availProblems[] = $service->description;
		}

		if ($service->display_status == 5) {
			$unknowns++;
		}
	}
}
if (count($services) === $unknowns) {
	print "IC - Desconhecido (Verificar problemas de checagem)".PHP_EOL;
	exit(2);
}
if (count($availProblems) > 0) {
	print "IC - Critical: ".implode(", ", $availProblems).PHP_EOL;
	exit(2);
}
print "IC - Ok".PHP_EOL;
exit(0);
