#!/bin/bash

# check if grafana running
RUNNING=`systemctl status gearman-utils`
RETVAL=$?
if [ $RETVAL -ne 0 ];
then
        echo "gearman-utils is not running, starting it"
        STARTGRAFANA=`systemctl start gearman-utils`
else
        echo "gearman-utils is running"
fi

# check if grafana running
RUNNING=`systemctl status grafana-server`
RETVAL=$?
if [ $RETVAL -ne 0 ];
then
        echo "Grafana not running, restarting it"
        STARTGRAFANA=`systemctl start grafana-server`
else
        echo "Grafana is running, neat!"
fi

# Cluster vs single node
FILE="/usr/local/opmon/etc/jobservers";
LINE=0
if [ -f $FILE ];
then
        LINE=`/bin/cat /usr/local/opmon/etc/jobservers | grep "127.0.0.1" | /usr/bin/wc -l`
else
	echo $FILE"not found"
	exit 0
fi
if [ $LINE -eq 0 ];
then
	echo "Cluster mode - no action"
	exit 0
fi

# check if opmon running
RUNNING=`systemctl status opmon`
RETVAL=$?
if [ $RETVAL -ne 0 ];
then
        echo "OpMon not running, starting it"
        STARTOPMON=`systemctl start opmon`
else
        echo "OpMon is running, all cool"
fi

# check if gearmand running
RUNNING=`systemctl status gearmand`
RETVAL=$?
if [ $RETVAL -ne 0 ];
then
        echo "Gearmand not running, starting it"
	STARTGRAFANA=`systemctl status gearmand`
else
	echo "Gearmand is running, rock'nd roll!"
fi

exit 0
